<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>wims: PGT storage</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="examples.html"><span>Examples</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>PGT storage<br/>
<small>
[<a class="el" href="group__internal_proxy.html">CAS Proxy features (CAS 2.0, Proxy Granting Tickets)</a>]</small>
</h1><table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Classes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_p_g_t_storage.html">PGTStorage</a></td></tr>
<tr><td colspan="2"><h2>Modules</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__internal_p_g_t_storage_d_b.html">PGT storage in a database</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__internal_p_g_t_storage_file.html">PGT storage on the filesystem</a></td></tr>
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__internal_p_g_t_storage.html#ga322a10ebbb6c3ef2e0d114fa83171a8a">CASClient::initPGTStorage</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__internal_p_g_t_storage.html#ga3f1650d36cad4d7a70cb4b37b2a9b6b7">CASClient::storePGT</a> ($pgt, $pgt_iou)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__internal_p_g_t_storage.html#ga0226ea3ecb328552d11dec260b75e7af">CASClient::loadPGT</a> ($pgt_iou)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__internal_p_g_t_storage.html#ga24dbbca8c79e42dacd44d87b94df1336">CASClient::setPGTStorageFile</a> ($format='', $path='')</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__internal_p_g_t_storage.html#ga885e4e413e69098a3a514427cd5addb4">CASClient::setPGTStorageDB</a> ($user, $password, $database_type, $hostname, $port, $database, $table)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__internal_p_g_t_storage.html#gaff6d96062187548ffba93dd7edbca563">CASClient::validatePGT</a> (&amp;$validate_url, $text_response, $tree_response)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__internal_p_g_t_storage.html#ga6653e51d995e8a13a2f758f93e7dc7a0">CASClient::retrievePT</a> ($target_service, &amp;$err_code, &amp;$err_msg)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__internal_p_g_t_storage.html#gad615ece3809389418cc18b099369f2a4">CASClient::readURL</a> ($url, $cookies, &amp;$headers, &amp;$body, &amp;$err_msg)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__internal_p_g_t_storage.html#ga3cfb41ba29adf2aa9bdb2cddb1564e8c">CASClient::_curl_read_headers</a> ($ch, $header)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__internal_p_g_t_storage.html#ga193806008e1fc68c4d8f384366f13b3e">CASClient::serviceWeb</a> ($url, &amp;$err_code, &amp;$output)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__internal_p_g_t_storage.html#ga11310ac24c9f5405129b2a47de8d20ee">CASClient::serviceMail</a> ($url, $flags, &amp;$err_code, &amp;$err_msg, &amp;$pt)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__internal_p_g_t_storage.html#gac299ce6c729e03225f8f0ca50ef7c728">PGTStorage::PGTStorage</a> ($cas_parent)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__internal_p_g_t_storage.html#gaab68db1fc471c7015ed776848c8becb6">PGTStorage::getStorageType</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__internal_p_g_t_storage.html#ga424a5265cde843c651792a41ed9938bb">PGTStorage::getStorageInfo</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__internal_p_g_t_storage.html#ga1224ea8e191f8b78d2b483dc9fd7405e">PGTStorage::setErrorMessage</a> ($error_message)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__internal_p_g_t_storage.html#gabf46978526a35a181d361916c5b9854c">PGTStorage::getErrorMessage</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__internal_p_g_t_storage.html#ga879c6c061d1208acf2a62e3a67fdde86">PGTStorage::isInitialized</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__internal_p_g_t_storage.html#gadda668067cd9c3a7e42cf74b2a7d481a">PGTStorage::init</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__internal_p_g_t_storage.html#ga2fd0dae57955ab41b1f2bada1bbe695a">PGTStorage::write</a> ($pgt, $pgt_iou)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__internal_p_g_t_storage.html#ga3148e55680c3d0031212ba7e829c681e">PGTStorage::read</a> ($pgt_iou)</td></tr>
<tr><td colspan="2"><h2>Variables</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__internal_p_g_t_storage.html#gab6c9bdf5c43999a3b8b8e35036cb491d">CASClient::$_pgt_storage</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__internal_p_g_t_storage.html#ga7637b991584dfbe8bdb2e9d243be66c9">CASClient::$_curl_headers</a> = array()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__internal_p_g_t_storage.html#gae176c1805208e7eaa621d47134945ab1">PGTStorage::$_error_message</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__internal_p_g_t_storage.html#gafd820856b62f9a6aa0199c3efe4576f4">PGTStorage::$_initialized</a></td></tr>
</table>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="ga3cfb41ba29adf2aa9bdb2cddb1564e8c"></a><!-- doxytag: member="CASClient::_curl_read_headers" ref="ga3cfb41ba29adf2aa9bdb2cddb1564e8c" args="($ch, $header)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">CASClient::_curl_read_headers </td>
          <td>(</td>
          <td class="paramtype">$&nbsp;</td>
          <td class="paramname"> <em>ch</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">$&nbsp;</td>
          <td class="paramname"> <em>header</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="gabf46978526a35a181d361916c5b9854c"></a><!-- doxytag: member="PGTStorage::getErrorMessage" ref="gabf46978526a35a181d361916c5b9854c" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">PGTStorage::getErrorMessage </td>
          <td>(</td>
          <td class="paramname"></td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>This method returns an error message set by <a class="el" href="group__internal_p_g_t_storage.html#ga1224ea8e191f8b78d2b483dc9fd7405e">PGTStorage::setErrorMessage()</a>.</p>
<dl class="return"><dt><b>Returns:</b></dt><dd>an error message when set by <a class="el" href="group__internal_p_g_t_storage.html#ga1224ea8e191f8b78d2b483dc9fd7405e">PGTStorage::setErrorMessage()</a>, FALSE otherwise.</dd></dl>
<dl class="deprecated"><dt><b><a class="el" href="deprecated.html#_deprecated000003">Deprecated:</a></b></dt><dd>not used. </dd></dl>

</div>
</div>
<a class="anchor" id="ga424a5265cde843c651792a41ed9938bb"></a><!-- doxytag: member="PGTStorage::getStorageInfo" ref="ga424a5265cde843c651792a41ed9938bb" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">PGTStorage::getStorageInfo </td>
          <td>(</td>
          <td class="paramname"></td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>This virtual method returns an informational string giving informations on the parameters of the storage.(used for debugging purposes). </p>

<p>Reimplemented in <a class="el" href="group__internal_p_g_t_storage_d_b.html#ga08688e74edbccefdff0033c1b7eb30a0">PGTStorageDB</a>, and <a class="el" href="group__internal_p_g_t_storage_file.html#gaba32bbc45e02eecb439136ef152b887e">PGTStorageFile</a>.</p>

</div>
</div>
<a class="anchor" id="gaab68db1fc471c7015ed776848c8becb6"></a><!-- doxytag: member="PGTStorage::getStorageType" ref="gaab68db1fc471c7015ed776848c8becb6" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">PGTStorage::getStorageType </td>
          <td>(</td>
          <td class="paramname"></td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>This virtual method returns an informational string giving the type of storage used by the object (used for debugging purposes). </p>

<p>Reimplemented in <a class="el" href="group__internal_p_g_t_storage_d_b.html#ga7308e1c19eea89d61f4cc0117f28cca5">PGTStorageDB</a>, and <a class="el" href="group__internal_p_g_t_storage_file.html#ga9b54c40d39ce33d8266086d93a64cedd">PGTStorageFile</a>.</p>

</div>
</div>
<a class="anchor" id="gadda668067cd9c3a7e42cf74b2a7d481a"></a><!-- doxytag: member="PGTStorage::init" ref="gadda668067cd9c3a7e42cf74b2a7d481a" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">PGTStorage::init </td>
          <td>(</td>
          <td class="paramname"></td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>This virtual method initializes the object. </p>

<p>Reimplemented in <a class="el" href="group__internal_p_g_t_storage_d_b.html#ga30a95297b215c8e290405536dade24cd">PGTStorageDB</a>, and <a class="el" href="group__internal_p_g_t_storage_file.html#ga0c543731e0444b7e106e64853d996ae7">PGTStorageFile</a>.</p>

</div>
</div>
<a class="anchor" id="ga322a10ebbb6c3ef2e0d114fa83171a8a"></a><!-- doxytag: member="CASClient::initPGTStorage" ref="ga322a10ebbb6c3ef2e0d114fa83171a8a" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">CASClient::initPGTStorage </td>
          <td>(</td>
          <td class="paramname"></td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [private, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>This method is used to initialize the storage of PGT's. Halts on error. </p>

</div>
</div>
<a class="anchor" id="ga879c6c061d1208acf2a62e3a67fdde86"></a><!-- doxytag: member="PGTStorage::isInitialized" ref="ga879c6c061d1208acf2a62e3a67fdde86" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">PGTStorage::isInitialized </td>
          <td>(</td>
          <td class="paramname"></td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>This method tells if the storage has already been intialized.</p>
<dl class="return"><dt><b>Returns:</b></dt><dd>a boolean </dd></dl>

</div>
</div>
<a class="anchor" id="ga0226ea3ecb328552d11dec260b75e7af"></a><!-- doxytag: member="CASClient::loadPGT" ref="ga0226ea3ecb328552d11dec260b75e7af" args="($pgt_iou)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">CASClient::loadPGT </td>
          <td>(</td>
          <td class="paramtype">$&nbsp;</td>
          <td class="paramname"> <em>pgt_iou</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [private, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>This method reads a PGT from its Iou and deletes the corresponding storage entry.</p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>$pgt_iou</em>&nbsp;</td><td>the PGT Iou</td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>The PGT corresponding to the Iou, FALSE when not found. </dd></dl>

</div>
</div>
<a class="anchor" id="gac299ce6c729e03225f8f0ca50ef7c728"></a><!-- doxytag: member="PGTStorage::PGTStorage" ref="gac299ce6c729e03225f8f0ca50ef7c728" args="($cas_parent)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">PGTStorage::PGTStorage </td>
          <td>(</td>
          <td class="paramtype">$&nbsp;</td>
          <td class="paramname"> <em>cas_parent</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>The constructor of the class, should be called only by inherited classes.</p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>$cas_parent</em>&nbsp;</td><td>the CASclient instance that creates the current object. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga3148e55680c3d0031212ba7e829c681e"></a><!-- doxytag: member="PGTStorage::read" ref="ga3148e55680c3d0031212ba7e829c681e" args="($pgt_iou)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">PGTStorage::read </td>
          <td>(</td>
          <td class="paramtype">$&nbsp;</td>
          <td class="paramname"> <em>pgt_iou</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>This virtual method reads a PGT corresponding to a PGT Iou and deletes the corresponding storage entry. </p>
<dl class="note"><dt><b>Note:</b></dt><dd>Should never be called.</dd></dl>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>$pgt_iou</em>&nbsp;</td><td>the PGT iou </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented in <a class="el" href="group__internal_p_g_t_storage_file.html#ga7ae8e91538f183e5744b71fe7b6eaee4">PGTStorageFile</a>.</p>

</div>
</div>
<a class="anchor" id="gad615ece3809389418cc18b099369f2a4"></a><!-- doxytag: member="CASClient::readURL" ref="gad615ece3809389418cc18b099369f2a4" args="($url, $cookies, &amp;$headers, &amp;$body, &amp;$err_msg)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">CASClient::readURL </td>
          <td>(</td>
          <td class="paramtype">$&nbsp;</td>
          <td class="paramname"> <em>url</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">$&nbsp;</td>
          <td class="paramname"> <em>cookies</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&amp;$&nbsp;</td>
          <td class="paramname"> <em>headers</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&amp;$&nbsp;</td>
          <td class="paramname"> <em>body</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&amp;$&nbsp;</td>
          <td class="paramname"> <em>err_msg</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [private, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>This method is used to acces a remote URL.</p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>$url</em>&nbsp;</td><td>the URL to access. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>$cookies</em>&nbsp;</td><td>an array containing cookies strings such as 'name=val' </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>$headers</em>&nbsp;</td><td>an array containing the HTTP header lines of the response (an empty array on failure). </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>$body</em>&nbsp;</td><td>the body of the response, as a string (empty on failure). </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>$err_msg</em>&nbsp;</td><td>an error message, filled on failure.</td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>TRUE on success, FALSE otherwise (in this later case, $err_msg contains an error message). </dd></dl>

</div>
</div>
<a class="anchor" id="ga6653e51d995e8a13a2f758f93e7dc7a0"></a><!-- doxytag: member="CASClient::retrievePT" ref="ga6653e51d995e8a13a2f758f93e7dc7a0" args="($target_service, &amp;$err_code, &amp;$err_msg)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">CASClient::retrievePT </td>
          <td>(</td>
          <td class="paramtype">$&nbsp;</td>
          <td class="paramname"> <em>target_service</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&amp;$&nbsp;</td>
          <td class="paramname"> <em>err_code</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&amp;$&nbsp;</td>
          <td class="paramname"> <em>err_msg</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [private, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>This method is used to retrieve PT's from the CAS server thanks to a PGT.</p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>$target_service</em>&nbsp;</td><td>the service to ask for with the PT. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>$err_code</em>&nbsp;</td><td>an error code (PHPCAS_SERVICE_OK on success). </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>$err_msg</em>&nbsp;</td><td>an error message (empty on success).</td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>a Proxy Ticket, or FALSE on error. </dd></dl>

</div>
</div>
<a class="anchor" id="ga11310ac24c9f5405129b2a47de8d20ee"></a><!-- doxytag: member="CASClient::serviceMail" ref="ga11310ac24c9f5405129b2a47de8d20ee" args="($url, $flags, &amp;$err_code, &amp;$err_msg, &amp;$pt)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">CASClient::serviceMail </td>
          <td>(</td>
          <td class="paramtype">$&nbsp;</td>
          <td class="paramname"> <em>url</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">$&nbsp;</td>
          <td class="paramname"> <em>flags</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&amp;$&nbsp;</td>
          <td class="paramname"> <em>err_code</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&amp;$&nbsp;</td>
          <td class="paramname"> <em>err_msg</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&amp;$&nbsp;</td>
          <td class="paramname"> <em>pt</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>This method is used to access an IMAP/POP3/NNTP service.</p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>$url</em>&nbsp;</td><td>a string giving the URL of the service, including the mailing box for IMAP URLs, as accepted by imap_open(). </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>$flags</em>&nbsp;</td><td>options given to imap_open(). </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>$err_code</em>&nbsp;</td><td>an error code Possible values are PHPCAS_SERVICE_OK (on success), PHPCAS_SERVICE_PT_NO_SERVER_RESPONSE, PHPCAS_SERVICE_PT_BAD_SERVER_RESPONSE, PHPCAS_SERVICE_PT_FAILURE, PHPCAS_SERVICE_NOT AVAILABLE. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>$err_msg</em>&nbsp;</td><td>an error message on failure </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>$pt</em>&nbsp;</td><td>the Proxy Ticket (PT) retrieved from the CAS server to access the URL on success, FALSE on error).</td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>an IMAP stream on success, FALSE otherwise (in this later case, $err_code gives the reason why it failed and $err_msg contains an error message). </dd></dl>

</div>
</div>
<a class="anchor" id="ga193806008e1fc68c4d8f384366f13b3e"></a><!-- doxytag: member="CASClient::serviceWeb" ref="ga193806008e1fc68c4d8f384366f13b3e" args="($url, &amp;$err_code, &amp;$output)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">CASClient::serviceWeb </td>
          <td>(</td>
          <td class="paramtype">$&nbsp;</td>
          <td class="paramname"> <em>url</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&amp;$&nbsp;</td>
          <td class="paramname"> <em>err_code</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&amp;$&nbsp;</td>
          <td class="paramname"> <em>output</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>This method is used to access an HTTP[S] service.</p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>$url</em>&nbsp;</td><td>the service to access. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>$err_code</em>&nbsp;</td><td>an error code Possible values are PHPCAS_SERVICE_OK (on success), PHPCAS_SERVICE_PT_NO_SERVER_RESPONSE, PHPCAS_SERVICE_PT_BAD_SERVER_RESPONSE, PHPCAS_SERVICE_PT_FAILURE, PHPCAS_SERVICE_NOT AVAILABLE. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>$output</em>&nbsp;</td><td>the output of the service (also used to give an error message on failure).</td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>TRUE on success, FALSE otherwise (in this later case, $err_code gives the reason why it failed and $output contains an error message). </dd></dl>

</div>
</div>
<a class="anchor" id="ga1224ea8e191f8b78d2b483dc9fd7405e"></a><!-- doxytag: member="PGTStorage::setErrorMessage" ref="ga1224ea8e191f8b78d2b483dc9fd7405e" args="($error_message)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">PGTStorage::setErrorMessage </td>
          <td>(</td>
          <td class="paramtype">$&nbsp;</td>
          <td class="paramname"> <em>error_message</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>This method sets en error message, which can be read later by <a class="el" href="group__internal_p_g_t_storage.html#gabf46978526a35a181d361916c5b9854c">PGTStorage::getErrorMessage()</a>.</p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>$error_message</em>&nbsp;</td><td>an error message</td></tr>
  </table>
  </dd>
</dl>
<dl class="deprecated"><dt><b><a class="el" href="deprecated.html#_deprecated000002">Deprecated:</a></b></dt><dd>not used. </dd></dl>

</div>
</div>
<a class="anchor" id="ga885e4e413e69098a3a514427cd5addb4"></a><!-- doxytag: member="CASClient::setPGTStorageDB" ref="ga885e4e413e69098a3a514427cd5addb4" args="($user, $password, $database_type, $hostname, $port, $database, $table)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">CASClient::setPGTStorageDB </td>
          <td>(</td>
          <td class="paramtype">$&nbsp;</td>
          <td class="paramname"> <em>user</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">$&nbsp;</td>
          <td class="paramname"> <em>password</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">$&nbsp;</td>
          <td class="paramname"> <em>database_type</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">$&nbsp;</td>
          <td class="paramname"> <em>hostname</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">$&nbsp;</td>
          <td class="paramname"> <em>port</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">$&nbsp;</td>
          <td class="paramname"> <em>database</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">$&nbsp;</td>
          <td class="paramname"> <em>table</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>This method is used to tell <a class="el" href="classphp_c_a_s.html">phpCAS</a> to store the response of the CAS server to PGT requests into a database. </p>
<dl class="note"><dt><b>Note:</b></dt><dd>The connection to the database is done only when needed. As a consequence, bad parameters are detected only when initializing PGT storage.</dd></dl>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>$user</em>&nbsp;</td><td>the user to access the data with </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>$password</em>&nbsp;</td><td>the user's password </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>$database_type</em>&nbsp;</td><td>the type of the database hosting the data </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>$hostname</em>&nbsp;</td><td>the server hosting the database </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>$port</em>&nbsp;</td><td>the port the server is listening on </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>$database</em>&nbsp;</td><td>the name of the database </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>$table</em>&nbsp;</td><td>the name of the table storing the data </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga24dbbca8c79e42dacd44d87b94df1336"></a><!-- doxytag: member="CASClient::setPGTStorageFile" ref="ga24dbbca8c79e42dacd44d87b94df1336" args="($format='', $path='')" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">CASClient::setPGTStorageFile </td>
          <td>(</td>
          <td class="paramtype">$&nbsp;</td>
          <td class="paramname"> <em>format</em> = <code>''</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">$&nbsp;</td>
          <td class="paramname"> <em>path</em> = <code>''</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>This method is used to tell <a class="el" href="classphp_c_a_s.html">phpCAS</a> to store the response of the CAS server to PGT requests onto the filesystem.</p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>$format</em>&nbsp;</td><td>the format used to store the PGT's (`plain' and `xml' allowed) </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>$path</em>&nbsp;</td><td>the path where the PGT's should be stored </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga3f1650d36cad4d7a70cb4b37b2a9b6b7"></a><!-- doxytag: member="CASClient::storePGT" ref="ga3f1650d36cad4d7a70cb4b37b2a9b6b7" args="($pgt, $pgt_iou)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">CASClient::storePGT </td>
          <td>(</td>
          <td class="paramtype">$&nbsp;</td>
          <td class="paramname"> <em>pgt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">$&nbsp;</td>
          <td class="paramname"> <em>pgt_iou</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [private, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>This method stores a PGT. Halts on error.</p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>$pgt</em>&nbsp;</td><td>the PGT to store </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>$pgt_iou</em>&nbsp;</td><td>its corresponding Iou </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="gaff6d96062187548ffba93dd7edbca563"></a><!-- doxytag: member="CASClient::validatePGT" ref="gaff6d96062187548ffba93dd7edbca563" args="(&amp;$validate_url, $text_response, $tree_response)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">CASClient::validatePGT </td>
          <td>(</td>
          <td class="paramtype">&amp;$&nbsp;</td>
          <td class="paramname"> <em>validate_url</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">$&nbsp;</td>
          <td class="paramname"> <em>text_response</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">$&nbsp;</td>
          <td class="paramname"> <em>tree_response</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [private, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>This method is used to validate a PGT; halt on failure.</p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>$validate_url</em>&nbsp;</td><td>the URL of the request to the CAS server. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>$text_response</em>&nbsp;</td><td>the response of the CAS server, as is (XML text); result of <a class="el" href="group__internal_basic.html#gacf3f1b530d4e029b3124558cc74d56cb">CASClient::validateST()</a> or <a class="el" href="group__internal_proxied.html#ga59ed21e8f3d40c8f33d277ca7ea3224f">CASClient::validatePT()</a>. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>$tree_response</em>&nbsp;</td><td>the response of the CAS server, as a DOM XML tree; result of <a class="el" href="group__internal_basic.html#gacf3f1b530d4e029b3124558cc74d56cb">CASClient::validateST()</a> or <a class="el" href="group__internal_proxied.html#ga59ed21e8f3d40c8f33d277ca7ea3224f">CASClient::validatePT()</a>.</td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>bool TRUE when successfull, halt otherwise by calling <a class="el" href="group__internal_misc.html#ga4dda8e03389ad8a515d4e45cb42859ca">CASClient::authError()</a>. </dd></dl>

</div>
</div>
<a class="anchor" id="ga2fd0dae57955ab41b1f2bada1bbe695a"></a><!-- doxytag: member="PGTStorage::write" ref="ga2fd0dae57955ab41b1f2bada1bbe695a" args="($pgt, $pgt_iou)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">PGTStorage::write </td>
          <td>(</td>
          <td class="paramtype">$&nbsp;</td>
          <td class="paramname"> <em>pgt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">$&nbsp;</td>
          <td class="paramname"> <em>pgt_iou</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>This virtual method stores a PGT and its corresponding PGT Iuo. </p>
<dl class="note"><dt><b>Note:</b></dt><dd>Should never be called.</dd></dl>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>$pgt</em>&nbsp;</td><td>the PGT </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>$pgt_iou</em>&nbsp;</td><td>the PGT iou </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented in <a class="el" href="group__internal_p_g_t_storage_file.html#ga4b0f3d6fce391a191fa33671d9657844">PGTStorageFile</a>.</p>

</div>
</div>
<hr/><h2>Variable Documentation</h2>
<a class="anchor" id="ga7637b991584dfbe8bdb2e9d243be66c9"></a><!-- doxytag: member="CASClient::$_curl_headers" ref="ga7637b991584dfbe8bdb2e9d243be66c9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">CASClient::$_curl_headers = array()<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>This method is the callback used by readURL method to request HTTP headers. </p>

</div>
</div>
<a class="anchor" id="gae176c1805208e7eaa621d47134945ab1"></a><!-- doxytag: member="PGTStorage::$_error_message" ref="gae176c1805208e7eaa621d47134945ab1" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">PGTStorage::$_error_message<code> [private, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>string used to store an error message. Written by <a class="el" href="group__internal_p_g_t_storage.html#ga1224ea8e191f8b78d2b483dc9fd7405e">PGTStorage::setErrorMessage()</a>, read by <a class="el" href="group__internal_p_g_t_storage.html#gabf46978526a35a181d361916c5b9854c">PGTStorage::getErrorMessage()</a>.</p>
<dl class="deprecated"><dt><b><a class="el" href="deprecated.html#_deprecated000001">Deprecated:</a></b></dt><dd>not used. </dd></dl>

</div>
</div>
<a class="anchor" id="gafd820856b62f9a6aa0199c3efe4576f4"></a><!-- doxytag: member="PGTStorage::$_initialized" ref="gafd820856b62f9a6aa0199c3efe4576f4" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">PGTStorage::$_initialized<code> [private, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>a boolean telling if the storage has already been initialized. Written by <a class="el" href="group__internal_p_g_t_storage.html#gadda668067cd9c3a7e42cf74b2a7d481a">PGTStorage::init()</a>, read by <a class="el" href="group__internal_p_g_t_storage.html#ga879c6c061d1208acf2a62e3a67fdde86">PGTStorage::isInitialized()</a>. </p>

</div>
</div>
<a class="anchor" id="gab6c9bdf5c43999a3b8b8e35036cb491d"></a><!-- doxytag: member="CASClient::$_pgt_storage" ref="gab6c9bdf5c43999a3b8b8e35036cb491d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">CASClient::$_pgt_storage<code> [private, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>an instance of a class inheriting of <a class="el" href="class_p_g_t_storage.html">PGTStorage</a>, used to deal with PGT storage. Created by <a class="el" href="group__internal_p_g_t_storage.html#ga24dbbca8c79e42dacd44d87b94df1336">CASClient::setPGTStorageFile()</a> or <a class="el" href="group__internal_p_g_t_storage.html#ga885e4e413e69098a3a514427cd5addb4">CASClient::setPGTStorageDB()</a>, used by <a class="el" href="group__internal_p_g_t_storage.html#ga24dbbca8c79e42dacd44d87b94df1336">CASClient::setPGTStorageFile()</a>, <a class="el" href="group__internal_p_g_t_storage.html#ga885e4e413e69098a3a514427cd5addb4">CASClient::setPGTStorageDB()</a> and <a class="el" href="group__internal_p_g_t_storage.html#ga322a10ebbb6c3ef2e0d114fa83171a8a">CASClient::initPGTStorage()</a>. </p>

</div>
</div>
</div>
<hr size="1"/><address style="text-align: right;"><small>Generated on Thu Oct 8 11:33:56 2009 for wims by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
</body>
</html>
